package org.seasar.util.text.env.impl;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.Reader;
import java.util.Properties;

import org.seasar.util.text.env.LoadingFailedException;

/**
 * ϐ̂悤ɎQƂ邱Ƃ̏oAL[ƒl̃}bsOێNXłB <br>
 * ̎́C}bsOqAhLg`̃t@C烍[h܂B Cӂ̕GR[fBOgp邱Ƃo܂B
 * 
 * @author suga
 * @author Koichi Kobayashi
 */
public class HereDocumentEnvironment extends AbstractEnvironment {
    protected static final String LINE_SEP = System.getProperty("line.separator");
    protected static final int LINE_SEP_LENGTH = LINE_SEP.length();

    protected final Properties properties = new Properties();

    /**
     * <code>key</code> ɑΉtꂽlԂ܂B <br>
     * <code>key</code> ɒlΉtĂȂꍇ́A <code>null</code> Ԃ܂B
     * 
     * @param key
     *            L[
     * @return <code>key</code> ɑΉtꂽl
     */
    public String getProperty(final String key) {
        return properties.getProperty(key);
    }

    /**
     * vbgtH[ftHg̕GR[fBOŃ\[Xǂݍ݂܂B
     * 
     * @param resourceName
     *            \[X
     * @exception LoadingFailedException
     *                \[X̓ǂݍݒɃG[ꍇɃX[܂
     */
    public void load(final String resourceName) {
        try {
            load(new InputStreamReader(getResourceAsInputStream(resourceName)));
        }
        catch (final LoadingFailedException e) {
            throw e;
        }
        catch (final Exception e) {
            throw new LoadingFailedException(e);
        }
    }

    /**
     * w̕GR[fBOŃ\[Xǂݍ݂܂B
     * 
     * @param resourceName
     *            \[X
     * @exception LoadingFailedException
     *                \[X̓ǂݍݒɃG[ꍇɃX[܂
     */
    public void load(final String resourceName, final String encoding) {
        try {
            load(new InputStreamReader(getResourceAsInputStream(resourceName), encoding));
        }
        catch (final LoadingFailedException e) {
            throw e;
        }
        catch (final Exception e) {
            throw new LoadingFailedException(e);
        }
    }

    /**
     * qAhLgǂݍ݁AvpeBXgɐݒ肵܂B
     * 
     * @param reader
     *            Xg[
     * @throws IOException
     *             Xg[̓ǂݍݒɃG[ꍇɃX[܂
     */
    protected void load(final Reader reader) throws IOException {
        final BufferedReader br = new BufferedReader(reader);
        final StringBuffer sb = new StringBuffer();
        String key = null;
        String endMark = null;
        String line;
        while ((line = br.readLine()) != null) {
            if (endMark == null) {
                final int index = line.indexOf("<<");
                if (index > 0) {
                    key = line.substring(0, index).trim();
                    endMark = line.substring(index + 2).trim();
                }
            }
            else if (line.equals(endMark)) {
                sb.setLength(sb.length() - LINE_SEP_LENGTH);
                properties.put(key, new String(sb));
                key = null;
                endMark = null;
                sb.setLength(0);
            }
            else {
                sb.append(line);
                sb.append(LINE_SEP);
            }
        }
    }
}