package org.seasar.util.text.env.impl;

import java.io.InputStream;

import junit.framework.TestCase;

import org.seasar.util.text.env.KeyNotFoundException;
import org.seasar.util.text.env.LoadingFailedException;

/**
 * @author Koichi Kobayashi
 */
public class AbstractEnvironmentTest extends TestCase {
    public AbstractEnvironmentTest(String name) {
        super(name);
    }

    public void testGetResourceAsStream() {
        AbstractEnvironment env = new AbstractEnvironment() {
            protected String getProperty(String key) {
                return null;
            }
        };

        InputStream is = env
                .getResourceAsInputStream("org/seasar/util/text/env/impl/AbstractEnvironmentTest.class");
        assertNotNull(is);

        is = env.getResourceAsInputStream("project.xml");
        assertNotNull(is);

        try {
            env.getResourceAsInputStream("hoge");
            fail();
        }
        catch (LoadingFailedException expected) {
        }
    }

    public void testGet() {
        AbstractEnvironment env = new AbstractEnvironment() {
            protected String getProperty(String key) {
                return null;
            }
        };

        try {
            env.get("");
            fail();
        }
        catch (KeyNotFoundException expected) {
        }

        env.setThrowKeyNotFoundException(false);
        String value = env.get("");
        assertNull(value);
    }
}